# Standard Libraries
import datetime

# Third Party Libraries
import factory
from django.utils import timezone
from patients.models import Patient

fk = factory.Faker

tz = timezone.tzinfo


class FacPatient(factory.django.DjangoModelFactory):
    class Meta:
        model = Patient

    name = fk('last_name', locale="fr_FR")
    firstname = fk('first_name', locale="fr_FR")
    birthdate = fk('past_date', start_date="-30y", tzinfo=datetime.tzinfo())
    street = fk('street_address', locale="fr_FR")
    city = fk('city', locale="fr_FR")
    postalcode = fk('zipcode')
    phonenumber = "0381395685"
    email = fk('email', locale="fr_FR")
    alive = True
    sexe = fk('pybool')
